package db

import (
	"context"
	"testing"

	"git.nochill.in/nochill/naice_pos/util"
	"github.com/google/uuid"
	"github.com/stretchr/testify/require"
)

func createRandomCustomer(t *testing.T) (Customer, CreateCustomersParams) {
	arg := CreateCustomersParams{
		MerchantID: uuid.MustParse("7e525a4b-4208-4f05-99a1-a75df475dd9b"),
		Name:       util.RandomString(10),
	}

	customer, err := testQueries.CreateCustomers(context.Background(), arg)
	require.NoError(t, err)

	return customer, arg

}
func TestCreateCustomer(t *testing.T) {
	supplier, arg := createRandomCustomer(t)

	require.Equal(t, arg.Name, supplier.Name)
	require.Equal(t, arg.MerchantID, supplier.MerchantID)

	require.NotZero(t, supplier.ID)
	require.NotZero(t, supplier.CreatedAt)
	require.NotZero(t, supplier.UpdatedAt)

}
